/**
    problema Concert
    clasa a 9-a
    autor: mrd. Razvan-Daniel Zoltan

    Complexitate: O(T * N * M)
    Punctaj estimat: 20p
**/

#include <fstream>

using namespace std;

ifstream fin("concert.in");
ofstream fout("concert.out");

const int NMAX = 2000;

int rows, columns, numberOfUpdates, numberOfQueries;
int matrix[NMAX + 1][NMAX + 1];

void read() {
    fin >> rows >> columns;
    for (int i = 1; i <= rows; ++i) {
        for (int j = 1; j <= columns; ++j) {
            fin >> matrix[i][j];
        }
    }
}

void update() {
    fin >> numberOfUpdates;
    int x1, y1, x2, y2;
    while (numberOfUpdates--) {
        fin >> x1 >> y1 >> x2 >> y2;
        for (int i = x1; i <= x2; ++i) {
            for (int j = y1; j <= y2; ++j) {
                if (matrix[i][j] == 0) {
                    matrix[i][j] = 1;
                }
                else {
                    matrix[i][j] = 0;
                }
            }
        }
    }
}

void query() {
    fin >> numberOfQueries;
    int x, y;
    while (numberOfQueries--) {
        fin >> x >> y;
        fout << matrix[x][y] << '\n';
    }
}

int main()
{
    read();
    update();
    query();

    fin.close();
    fout.close();
    return 0;
}
