/**
    problema Concert
    clasa a 9-a
    autor: mrd. Razvan-Daniel Zoltan

    Complexitate: O(N * M + T)
    Punctaj estimat: 100p
**/

#include <fstream>

using namespace std;

ifstream fin("concert.in");
ofstream fout("concert.out");

const int NMAX = 2000;

int rows, columns, numberOfUpdates, numberOfQueries;
int matrix[NMAX + 1][NMAX + 1];

// vom folosi "Smenul lui Mars" in varianta 2D
int mars[NMAX + 2][NMAX + 2];

void read() {
    fin >> rows >> columns;
    for (int i = 1; i <= rows; ++i) {
        for (int j = 1; j <= columns; ++j) {
            fin >> matrix[i][j];
        }
    }
}

void update() {
    fin >> numberOfUpdates;
    int x1, y1, x2, y2;
    while (numberOfUpdates--) {
        fin >> x1 >> y1 >> x2 >> y2;
        ++mars[x1][y1];
        --mars[x1][y2 + 1];
        --mars[x2 + 1][y1];
        ++mars[x2 + 1][y2 + 1];
    }
}

void preprocess() {
    for (int i = 1; i <= rows; ++i) {
        for (int j = 1; j <= columns; ++j) {
            // construim sume partiale
            mars[i][j] += mars[i - 1][j] + mars[i][j - 1] - mars[i - 1][j - 1];
        }
    }
}

void query() {
    fin >> numberOfQueries;
    int x, y;
    while (numberOfQueries--) {
        fin >> x >> y;
        if (mars[x][y] % 2 == 0) {
            fout << matrix[x][y] << '\n';
        }
        else {
            fout << 1 - matrix[x][y] << '\n';
        }
    }
}

int main()
{
    read();
    update();
    preprocess();
    query();

    fin.close();
    fout.close();
    return 0;
}
